<template>
  <div class="row items-start">
    <div class="col-12" style="margin-bottom: 10px">
      <q-btn-group>
        <q-btn icon="add" color="green" @click="jmlImage = jmlImage + 1" />
      </q-btn-group>
    </div>
    <div class="col-md-2 col-sm-4 col-xs-6" style="padding: 10px">
      <q-file label-color="green" counter outlined label="Main Image" v-model="main_image" use-chips ref="mainImage"
              @input="mainImageUrlChange"
              accept="image/*" @clear="mainImageUrlChange">
        <template v-slot:prepend>
          <q-icon name="attach_file" />
        </template>
      </q-file>
      <q-img :src="mainImageUrl" v-if="mainImageUrl" >
        <div class="absolute-bottom-right text-subtitle2">
          <q-btn icon="delete" color="red" @click="deleteMainImage" />
        </div>
      </q-img>
    </div>

    <div class="col-md-2 col-sm-4 col-xs-6" v-for="jml in jmlImage" style="padding: 10px">
      <ProductImage @addImage="addImage" @deleteImage="deleteImage" />
    </div>

    <div class="col-12">
      <q-stepper-navigation>
        <q-btn @click="submitFile" color="primary" label="Selanjutnya" />
      </q-stepper-navigation>
    </div>
  </div>
</template>

<script>
import ProductImage from 'components/Product/Image'
export default {
  name: 'CreateProductStep1',

  components: {
    ProductImage
  },

  data () {
    return {
      main_image: null,
      image: [],
      jmlImage: 1,
      mainImageUrl: null
    }
  },

  mounted() {
    this.mainImageUrl = this.$attrs.product.main_image
  },

  methods: {
    deleteMainImage() {
      this.$refs.mainImage.removeAtIndex(0);
    },
    mainImageUrlChange(val) {
      if (val) {
        this.mainImageUrl = URL.createObjectURL(val);
      } else {
        this.mainImageUrl = null;
      }
    },

    addImage(val) {
      this.image.push(val)
    },

    deleteImage(val) {
      this.image.splice(this.image.indexOf(val), 1);
    },

    deleteAllImage() {
      this.jmlImage = 1;
      this.image.splice(1, this.image.length - 1);
    },

    submitFile() {
      if (this.image.length && this.main_image) {
        let file = {
          main_image: this.main_image,
          image: this.image
        }
        this.$store.dispatch("product/addProductImage", file);
        this.$emit("submit");
      } else {
        this.$q.notify({
          message: "Mohon Tambahkan File",
          color: "red",
          position: "top"
        })
      }

    }
  },
}
</script>
